//
// Software License for AMDiS
//
// Copyright (c) 2010 Dresden University of Technology 
// All rights reserved.
// Authors: Simon Vey, Thomas Witkowski et al.
//
// This file is part of AMDiS
//
// See also license.opensource.txt in the distribution.


#include "DofComm.h"

namespace AMDiS {

  using namespace std;

  void DofComm::removeEmpty()
  {
    DataIter dit = data.begin();
    while (dit != data.end()) {
      FeMapIter it = dit->second.begin();
      while (it != dit->second.end()) {
	if (it->second.size() == 0) {
	  const FiniteElemSpace *fe = it->first;
	  ++it;
	  dit->second.erase(fe);
	} else
	  ++it;
      }
      
      if (dit->second.size() == 0)
	data.erase(dit++);
      else
	++dit;
    }
  }

  
  void DofComm::Iterator::setNextFeMap()
  {
    if (dataIter != dofComm.data.end()) {
      feMapIter = dataIter->second.begin();
      
      if (traverseFeSpace != NULL) {
	TEST_EXIT_DBG(dataIter->second.count(traverseFeSpace))
	  ("Should not happen!\n");
	
	while (feMapIter->first != traverseFeSpace &&
	       feMapIter != dataIter->second.end())
	  ++feMapIter;
	
	TEST_EXIT_DBG(feMapIter != dataIter->second.end() &&
		      feMapIter->first == traverseFeSpace)
	  ("Should not happen!\n");
      }
      
      if (feMapIter != dataIter->second.end())
	dofIter = feMapIter->second.begin();
      
      dofCounter = 0;
    }
  }

}
